﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;   //para BackgroundWorker (hilo)

namespace EscribirCoord
{
    /// <summary>
    /// Lógica de interacción para MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {        
        /*Definición de subprocesos ciclicos*/
        System.Windows.Forms.Timer lectura = new System.Windows.Forms.Timer();            
        
        /*Variables globales de la clase*/
        int accion = 0;
        int contarclick = 0;        
        int manoizqclick = 0;
        int primero = 0;
        int modo = 0;  // 0 -> modo guardar operacion; 1 -> modo ejecucion
    
        public MainWindow()
        {
            InitializeComponent();            
            lectura.Tick += new EventHandler(lectura_Tick); 
            lectura.Interval = 50; //50 ms                                          
        }
        #region EVENTOS DE LOS BOTONES
        private void iniciarClick(object sender, RoutedEventArgs e)
        {
            limpiarAcciones();
            accion = 0;                                   // Empieza el guardado de acciones
            modo = 0;            
            lectura.Enabled = true;                       // Enable the timer
            lectura.Start();                              // Start the timer           
        }
        private void pararClick(object sender, RoutedEventArgs e)
        {
            lectura.Stop();
            primero = 0;                                  
            limpiarCampos();            
        }        
        private void ComprobarClick(object sender, RoutedEventArgs e)
        {                        
            if (primero == 0)
            {
                primero = 1;
                accion = 0;
            }
            lectura.Stop();
            limpiarCampos();
            mostrarOperacionReferencia(accion);
            mostrarOperacionEjecucion(accion);
            comprobarOperacion(accion);
            accion++;
        }
       
        private void ejecucionClick(object sender, RoutedEventArgs e)
        {            
            accion = 0;
            modo = 1;
            lectura.Start();
        }
        #endregion
        #region SUBPROCESOS CICLICOS
        void lectura_Tick(object sender, EventArgs e)
        {
            manoizqclick = 0;
            //Posicion Mano Izquierda
            coordxi.Text = MiClase.MiVariable[1];
            coordyi.Text = MiClase.MiVariable[5];
            coordzi.Text = MiClase.MiVariable[3];

            quatwi.Text = MiClase.MiVariable[7];
            quatxi.Text = MiClase.MiVariable[9];
            quatyi.Text = MiClase.MiVariable[11];
            quatzi.Text = MiClase.MiVariable[13];

            manoizqclick = int.Parse(MiClase.MiVariable[15]);
            //Posicion Mano Derecha                        
            coordxd.Text = MiClase.MiVariable[16];
            coordyd.Text = MiClase.MiVariable[20];
            coordzd.Text = MiClase.MiVariable[18];

            quatwd.Text = MiClase.MiVariable[22];
            quatxd.Text = MiClase.MiVariable[24];
            quatyd.Text = MiClase.MiVariable[26];
            quatzd.Text = MiClase.MiVariable[28];
            if ((manoizqclick == 0) && (contarclick == 1))
            {
                contarclick = 0;
            }
            if ((manoizqclick == 1) && (contarclick == 0))
            {                
                contarclick = 1;
                guardarOperacion(modo,accion,0);    //modo 0, referencia; tipo 0, accion click                  
                accion++;          
            }
            if ((manoizqclick == 2) && (contarclick == 0))
            {
                contarclick = 1;    //modo 0, referencia; tipo 1, accion doble-click
                guardarOperacion(modo,accion,1);
                accion++;             
            }
        }
        #endregion
        #region MÉTODOS 
        private void guardarOperacion(int modo, int num_accion, int tipo)
        {
            DateTime ahora = DateTime.Now;
            Global.SetValue(modo, num_accion, 0, int.Parse(MiClase.MiVariable[1]));
            Global.SetValue(modo, num_accion, 1, int.Parse(MiClase.MiVariable[5]));
            Global.SetValue(modo, num_accion, 2, int.Parse(MiClase.MiVariable[3]));
            Global.SetValue(modo, num_accion, 3, tipo);
            Global.SetValue(modo, num_accion, 4, ahora.Year);
            Global.SetValue(modo, num_accion, 5, ahora.Month);
            Global.SetValue(modo, num_accion, 6, ahora.Day);
            Global.SetValue(modo, num_accion, 7, ahora.Hour);
            Global.SetValue(modo, num_accion, 8, ahora.Minute);
            Global.SetValue(modo, num_accion, 9, ahora.Second);
        }
        private void mostrarOperacionReferencia(int num_accion)
        {
            coordxi.Text = Global.GetValue(0, num_accion, 0).ToString();
            coordyi.Text = Global.GetValue(0, num_accion, 1).ToString();
            coordzi.Text = Global.GetValue(0, num_accion, 2).ToString();

            switch (Global.GetValue(0, num_accion, 3))
            {
                case 0:
                    quatIzquierda.Text = "Operacion 1 click";
                    break;
                case 1:
                    quatIzquierda.Text = "Operacion 2 click";
                    break;
            }       
        }
        private void mostrarOperacionEjecucion(int num_accion)
        {
            coordxd.Text = Global.GetValue(1, num_accion, 0).ToString();
            coordyd.Text = Global.GetValue(1, num_accion, 1).ToString();
            coordzd.Text = Global.GetValue(1, num_accion, 2).ToString();

            switch (Global.GetValue(1, num_accion, 3))
            {
                case 0:                    
                    quatDerecha.Text = "Operacion 1 click";
                    break;
                case 1:
                    quatDerecha.Text = "Operacion 2 click";
                    break;
            }            
        }
        private int comprobarOperacion(int num_accion)
        {
            int resultado = 0;
            //Comprobar tipo de operación
            if ((Global.GetValue(0, num_accion, 3)) != (Global.GetValue(1, num_accion, 3)))
            {
                rectangulo.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
                resultado = 1;
                comprobar.Text = "Error de operación";
            }
            if (resultado != 1)
            {
                //Comprobar Ubicación si la operación a realizar es la adecuada
                for (int i = 0; i <= 2; i++) //tres coordenadas x,y,z
                {
                    //si la coordenada (x por ejemplo) de la operacion se sale 
                    //del rango, se pinta el rectangulo de color rojo
                    //comprobar rango inferior
                    if ((Global.GetValue(0, num_accion, i)) > (Global.GetValue(1, num_accion, i) + 50))
                    {
                        rectangulo.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
                        resultado = 2;
                        comprobar.Text = "Error de ubicación";
                        break;
                    }
                    //Comprobar rango superior
                    else if ((Global.GetValue(0, num_accion, i)) < (Global.GetValue(1, num_accion, i) - 50))
                    {
                        rectangulo.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 0, 0));
                        resultado = 2;
                        comprobar.Text = "Error de ubicación";
                        break;
                    }                    
                    else
                    {
                        rectangulo.Fill = new SolidColorBrush(Color.FromArgb(255, 0, 255, 0));
                        resultado = 0;
                        comprobar.Text = "Operación correcta";
                    }
                }
            }

            return resultado;
        }          
                 
        private void limpiarCampos()
        {
            coordxi.Text = "";
            coordyi.Text = "";
            coordzi.Text = "";

            quatIzquierda.Text = "";
            quatwi.Text = "";
            quatxi.Text = "";
            quatyi.Text = "";
            quatzi.Text = "";           

            coordxd.Text = "";
            coordyd.Text = "";
            coordzd.Text = "";

            quatDerecha.Text = "";
            quatwd.Text = "";
            quatxd.Text = "";
            quatyd.Text = "";
            quatzd.Text = "";

            comprobar.Text = "";
            rectangulo.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));  //blanco
        }
        private void limpiarAcciones()
        {
            for (int i=0; i <= accion; i++)
            {
                for (int j = 0; j <= 3; j++)
                {
                    Global.SetValue(0, i, j, 0);
                    Global.SetValue(1, i, j, 0);
                }
            }
        }
        #endregion
    }
}
