﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Automation;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Effects;
using System.Windows.Media.Imaging;
using System.Windows.Media.Media3D;
using System.Windows.Media.TextFormatting;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Shell;
using ThreeGear;

namespace EscribirCoord
{
    class PrintMessage
    {
        public PrintMessage(HandTrackingClient client_in)
        {
            client = client_in;

            // It is important to register the callbacks _before_ we Connect(),
            // or we will miss some important messages.
            client.MessageCallback += new MessageHandler(HandleEvent);
            client.ErrorCallback += new ErrorHandler(HandleError);
            client.Connect();
        }

        private void HandleEvent(HandTrackingMessage message)
        {
            if (typeof(PinchMessage).IsAssignableFrom(message.GetType()))
            {
                char[] delimiterChars = { ' ', '.'};

                string text = message.Serialize();

                string[] words = text.Split(delimiterChars);
                lock(this)
                {
                    MiClase.MiVariable = words;
                }
            }
        }

        private void HandleError(string err)
        {
            Console.WriteLine("ERROR: " + err);
        }

        readonly HandTrackingClient client;
    }
    class StartApp
    {
        /// <summary>
        /// Application Entry Point.
        /// </summary>
        [System.STAThreadAttribute()]
        [System.Diagnostics.DebuggerNonUserCodeAttribute()]
        public static void Main()
        {
            EscribirCoord.App app = new EscribirCoord.App();
            HandTrackingClient client = new HandTrackingClient();

            PrintMessage printMessage = new PrintMessage(client);
            app.InitializeComponent();            
            app.Run();
        }
    }
    public static class MiClase
    {
        public static string[] MiVariable; 
    }

    /***Matriz tridimensional global puntosxyz: [modo de guardado, nº de accion, datos sobre la accion]***/
    //modo de guardado -> 0 operacion  referencia    
    //                 -> 1 operacion ejecucion         
    //Datos sobre la accion:tipo de accion,cordenadas xyz,...¿fecha?:           
        //campo 0: cordenada x             
        //campo 1: cordenada y    
        //campo 2: cordenada z     
        //campo 3: tipo de accion   -> 0 Click
        //                          -> 1 Doble Click         
    public class Global
    {
        static int[, ,] puntosxyz = new int[2,20,10];
        
        public static int[, ,] Puntosxyz
        {
            get { return puntosxyz; }
            set { puntosxyz = value; }
        } 
        public static void SetValue(int pos1, int pos2, int pos3, int value) 
        { 
            puntosxyz[pos1,pos2,pos3] = value;
        } 
        public static int GetValue(int pos1, int pos2, int pos3) 
        {
            return puntosxyz[pos1, pos2, pos3];
        } 
    }
}
