﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Forms;
using System.IO;

namespace ConfOperaciones
{
    /// <summary>
    /// Lógica de interacción para MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {        
        string rutaActividad;
        string nombreActividad;
        string Propiedades;

        string[] SRActividad = new string[2000];    //Las superficies de referencia de una actividad
        int contarSR = 0;

        //Variables Propiedades
        string nombreAct;
        int herramientaAct;
        int precisionPosicion;
        int precisionOrientacion;
        float[] desplazamientoHerr = new float[3]; //desviación de la posición del marcador principal
                                                   //respecto el efector final de la herrameinta
        int exactitudAct;
        int forma;
        float[] escalaEfector = new float[3];
        string ComentariosAct;
        string fechaAct;
        string duracionAct;
        float[] posCamara = new float[3];
        float[] oriCamara = new float[3];

        public MainWindow()
        {
            InitializeComponent();
        }

        private void SeleccionarActividad_Click(object sender, RoutedEventArgs e)
        {
            Stream myStream = null;
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.Filter = "txt files (*.txt)|*.txt";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;
            DialogResult result = openFileDialog1.ShowDialog();
            if (result.ToString() == "OK")
            {
                try
                {
                    if ((myStream = openFileDialog1.OpenFile()) != null)
                    {
                        using (myStream)
                        {
                            nombreActividad = openFileDialog1.FileName;
                            NombreAc.Text = nombreActividad;
                            cargarPropiedades(nombreActividad);
                        }
                    }
                }
                catch (Exception ex)
                {
                    System.Windows.Forms.MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
                }
            }
        }

        

        private void cargarPropiedades(string ruta)
        {
            using (System.IO.StreamReader sr = new System.IO.StreamReader(ruta, true))
            {
                string linea = null;
                linea = sr.ReadLine();

                contarSR = 0;
                while (linea != null)
                {
                    /**************Cargar Propiedades************/
                    if (contarSR == 0)
                    {
                        //Dividir mensaje por ;
                        string[] words;
                        char[] divisorEnPalabras = { ';' };
                        words = linea.Split(divisorEnPalabras);
                        //Cargar Proipiedades
                        nombreAct = words[0];
                        herramientaAct = Convert.ToInt32(words[1]); 
                        desplazamientoHerr[0] = float.Parse(words[2], new System.Globalization.CultureInfo("es-ES"));
                        desplazamientoHerr[1] = float.Parse(words[3], new System.Globalization.CultureInfo("es-ES"));
                        desplazamientoHerr[2] = float.Parse(words[4], new System.Globalization.CultureInfo("es-ES"));
                        exactitudAct = Convert.ToInt32(words[5]);
                        forma = Convert.ToInt32(words[6]);
                        escalaEfector[0] = float.Parse(words[7], new System.Globalization.CultureInfo("es-ES"));
                        escalaEfector[1] = float.Parse(words[8], new System.Globalization.CultureInfo("es-ES"));
                        escalaEfector[2] = float.Parse(words[9], new System.Globalization.CultureInfo("es-ES"));
                        ComentariosAct = words[10];
                        fechaAct = words[11];
                        duracionAct = words[12];
                        posCamara[0] = float.Parse(words[13], new System.Globalization.CultureInfo("es-ES"));
                        posCamara[1] = float.Parse(words[14], new System.Globalization.CultureInfo("es-ES"));
                        posCamara[2] = float.Parse(words[15], new System.Globalization.CultureInfo("es-ES"));
                        oriCamara[0] = float.Parse(words[16], new System.Globalization.CultureInfo("es-ES"));
                        oriCamara[1] = float.Parse(words[17], new System.Globalization.CultureInfo("es-ES"));
                        oriCamara[2] = float.Parse(words[18], new System.Globalization.CultureInfo("es-ES"));
                        precisionPosicion = Convert.ToInt32(words[19]);
                        precisionOrientacion = Convert.ToInt32(words[20]); 

                        //Representar Propiedades
                        NombreActividad.Text = nombreAct;                        
                        switch (herramientaAct)
                        {
                            case 0:
                                nombreHerramienta.SelectedIndex = 0;
                                break;
                            case 1:
                                nombreHerramienta.SelectedIndex = 1;
                                break;
                            case 2:
                                nombreHerramienta.SelectedIndex = 2;
                                break;
                            case 3:
                                nombreHerramienta.SelectedIndex = 3;
                                break;                            
                        }
                        switch (precisionPosicion)
                        {
                            case 0:
                                SeleccionPrecisionPosicion.SelectedIndex = 0;                                
                                break;
                            case 1:
                                SeleccionPrecisionPosicion.SelectedIndex = 1;
                                break;
                            case 2:
                                SeleccionPrecisionPosicion.SelectedIndex = 2;
                                break;
                            case 3:
                                SeleccionPrecisionPosicion.SelectedIndex = 3;
                                break;
                        }
                        switch (precisionOrientacion)
                        {
                            case 0:
                                SeleccionPrecisionOrientacion.SelectedIndex = 0;
                                break;
                            case 1:
                                SeleccionPrecisionOrientacion.SelectedIndex = 1;
                                break;
                            case 2:
                                SeleccionPrecisionOrientacion.SelectedIndex = 2;
                                break;
                            case 3:
                                SeleccionPrecisionOrientacion.SelectedIndex = 3;
                                break;
                        }                       
                        despHerrx.Text = desplazamientoHerr[0].ToString();
                        despHerry.Text = desplazamientoHerr[1].ToString();
                        despHerrz.Text = desplazamientoHerr[2].ToString();
                        switch (exactitudAct)
                        {
                            case 0:
                                SeleccionExactitud.SelectedIndex = 0;
                                break;
                            case 1:
                                SeleccionExactitud.SelectedIndex = 1;
                                break;
                            case 2:
                                SeleccionExactitud.SelectedIndex = 2;
                                break;
                            case 3:
                                SeleccionExactitud.SelectedIndex = 3;
                                break;                            
                        }
                        switch (forma)
                        {
                            case 0:
                                SeleccionForma.SelectedIndex = 0;
                                break;
                            case 1:
                                SeleccionForma.SelectedIndex = 1;
                                break;
                            case 2:
                                SeleccionForma.SelectedIndex = 2;
                                break;
                        }
                        EscalaEfecx.Text = escalaEfector[0].ToString();
                        EscalaEfecy.Text = escalaEfector[1].ToString();
                        EscalaEfecz.Text = escalaEfector[2].ToString();
                        Comentarios.Text = ComentariosAct;
                        fechaCreacion.Text = fechaAct;
                        Duracion.Text = duracionAct;
                        PosicionCamarax.Text = posCamara[0].ToString();
                        PosicionCamaray.Text = posCamara[1].ToString();
                        PosicionCamaraz.Text = posCamara[2].ToString();
                        OrientacionCamarax.Text = oriCamara[0].ToString();
                        OrientacionCamaray.Text = oriCamara[1].ToString();
                        OrientacionCamaraz.Text = oriCamara[2].ToString();
                    }
                    else
                    {
                        SRActividad[contarSR] = linea;                        
                    }
                    contarSR++;
                    linea = sr.ReadLine();
                }
            }
        }

        

        private void SeleccionarRuta_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.FolderBrowserDialog folderDlg = new System.Windows.Forms.FolderBrowserDialog();
            folderDlg.SelectedPath = "c:\\Proyecto\\Archivos\\Operaciones";

            folderDlg.ShowNewFolderButton = true;
            // Show the FolderBrowserDialog.
            DialogResult result = folderDlg.ShowDialog();
            if (result.ToString() == "OK")
            {
                rutaActividad = folderDlg.SelectedPath;
                NombreRutaAct.Text = rutaActividad;
                NuevaActividad(rutaActividad);
                cargarPropiedades(nombreActividad);
            }
        }

        private void NuevaActividad(string rutaAct)
        {
            nombreActividad = rutaAct + "/ActividadSR.txt";
            Propiedades = "Nombre;0;0;0;0;0;0;0;0;0;comentarios;0;0;-0,06352839;0,6350171;-1,875679;13;0;0;0;0;";

            using (System.IO.StreamWriter file = new System.IO.StreamWriter(nombreActividad, false))
            {
                file.WriteLine(Propiedades);
            }
        }

        private void GuardarPropiedades_Click(object sender, RoutedEventArgs e)
        {
            Propiedades = NombreActividad.Text + ";" + nombreHerramienta.SelectedIndex.ToString() + ";" +
                despHerrx.Text + ";" + despHerry.Text + ";" + despHerrz.Text + ";" +
                SeleccionExactitud.SelectedIndex.ToString() + ";" + SeleccionForma.SelectedIndex.ToString() + ";" +
                EscalaEfecx.Text + ";" + EscalaEfecy.Text + ";" + EscalaEfecz.Text + ";" + Comentarios.Text + ";" +
                fechaCreacion.Text + ";" + Duracion.Text + ";" + PosicionCamarax.Text + ";" +
                PosicionCamaray.Text + ";" + PosicionCamaraz.Text + ";" + OrientacionCamarax.Text + ";" +
                OrientacionCamaray.Text + ";" + OrientacionCamaraz.Text + ";" +
                SeleccionPrecisionPosicion.SelectedIndex.ToString() + ";" + SeleccionPrecisionOrientacion.SelectedIndex.ToString() + ";";
            using (StreamWriter sw = new StreamWriter(nombreActividad))
            {
                sw.WriteLine(Propiedades);
                for (int i = 1; i <= contarSR - 1; i++)
                {
                    if (SRActividad[i] != null)
                    {
                        sw.WriteLine(SRActividad[i]);
                    }
                }
            }
        }











        //private void GuardarPropiedades_Click(object sender, RoutedEventArgs e)
        //{
        //    using (StreamWriter sw = new StreamWriter(rutaPropiedad))
        //    {                
        //        sw.WriteLine(NombreActividad.Text);
        //        sw.WriteLine(SeleccionHerramienta.SelectedIndex.ToString());
        //        sw.WriteLine(SeleccionExactitud.SelectedIndex.ToString());                    
        //        sw.WriteLine(SeleccionForma.SelectedIndex.ToString());
        //        sw.WriteLine(AlturaEfec.Text);
        //        sw.WriteLine(AnchuraEfec.Text);
        //        sw.WriteLine(Comentarios.Text);   
        //    }


        //}

        //while (linea != null)
        //{
        //    switch (contador)
        //    {
        //        //Nombre Actividad
        //        case 0:
        //            NombreActividad.Text = linea;
        //            break;
        //        //herramienta Seleccionada
        //        case 1:
        //            int herr = Convert.ToInt32(linea);
        //            switch (herr)
        //            {
        //                case 0:
        //                    SeleccionHerramienta.SelectedIndex = 0;
        //                    break;
        //                case 1:
        //                    SeleccionHerramienta.SelectedIndex = 1;
        //                    break;
        //                case 2:
        //                    SeleccionHerramienta.SelectedIndex = 2;
        //                    break;
        //                case 3:
        //                    SeleccionHerramienta.SelectedIndex = 3;
        //                    break;
        //            }
        //            break;
        //        //Exactitud de la actividad
        //        case 2:
        //            int exac = Convert.ToInt32(linea);
        //            switch (exac)
        //            {
        //                case 0:
        //                    SeleccionExactitud.SelectedIndex = 0;
        //                    break;
        //                case 1:
        //                    SeleccionExactitud.SelectedIndex = 1;
        //                    break;
        //                case 2:
        //                    SeleccionExactitud.SelectedIndex = 2;
        //                    break;
        //                case 3:
        //                    SeleccionExactitud.SelectedIndex = 3;
        //                    break;
        //                case 4:
        //                    SeleccionExactitud.SelectedIndex = 4;
        //                    break;
        //                case 5:
        //                    SeleccionExactitud.SelectedIndex = 5;
        //                    break;
        //            }
        //            break;
        //        //Comentarios sobre la actividad
        //        case 3:
        //            int forma = Convert.ToInt32(linea);
        //            switch (forma)
        //            {
        //                case 0:
        //                    SeleccionForma.SelectedIndex = 0;
        //                    break;
        //                case 1:
        //                    SeleccionForma.SelectedIndex = 1;
        //                    break;
        //                case 2:
        //                    SeleccionForma.SelectedIndex = 2;
        //                    break;
        //            }
        //            break;
        //        //Forma del efector final
        //        case 4:
        //            int altura = Convert.ToInt32(linea);
        //            AlturaEfec.Text = linea;
        //            break;
        //        case 5:
        //            int anchura = Convert.ToInt32(linea);
        //            AnchuraEfec.Text = linea;
        //            break;
        //        case 6:
        //            Comentarios.Text = linea;
        //            break;

        //    }

        //    contador++;
        //    linea = sr.ReadLine();
        //}




        //private void SeleccionarOperacion_Click(object sender, RoutedEventArgs e)
        //{
        //    System.Windows.Forms.FolderBrowserDialog folderDlg = new System.Windows.Forms.FolderBrowserDialog();
        //    folderDlg.SelectedPath = "c:\\Proyecto\\Archivos\\Operaciones";

        //    folderDlg.ShowNewFolderButton = true;
        //    // Show the FolderBrowserDialog.
        //    DialogResult result = folderDlg.ShowDialog();
        //    if (result.ToString() == "OK")
        //    {
        //        rutaOperacion = folderDlg.SelectedPath;
        //        NombreOp.Text = rutaOperacion;

        //    }
        //}

        //private void SeleccionarPropiedad_Click(object sender, System.EventArgs e)
        //{
        //    Stream myStream = null;
        //    OpenFileDialog openFileDialog1 = new OpenFileDialog();

        //    openFileDialog1.InitialDirectory = rutaActividad;
        //    openFileDialog1.Filter = "txt files (*.txt)|*.txt";
        //    openFileDialog1.FilterIndex = 2;
        //    openFileDialog1.RestoreDirectory = true;
        //    DialogResult result = openFileDialog1.ShowDialog();
        //    if (result.ToString() == "OK")
        //    {
        //        try
        //        {
        //            if ((myStream = openFileDialog1.OpenFile()) != null)
        //            {                       
        //                using (myStream)
        //                {
        //                    rutaPropiedad = openFileDialog1.FileName;  
        //                    cargarPropiedades(openFileDialog1.FileName);
        //                }
        //            }
        //        }
        //        catch (Exception ex)
        //        {
        //            System.Windows.Forms.MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
        //        }
        //    }
        //}
    }
}
